package meerkat.voting.gui.configuration;

import meerkat.protobuf.BallotQuestionUIElementOuterClass;
import org.json.JSONException;

import java.io.FileOutputStream;
import java.io.IOException;

/**
 * Created by Vladimir Eliezer Tokarev on 11/5/2016.
 * This class uses the configuration creator which converts json configuration into normal binary proto file
 */
public class Converter {
    private final static String OUTPUTNAME = "configuration.bin";

    /**
     * Reads the json configuration from given path
     * @return VotingBoothConfiguration object
     * @throws IOException
     * @throws JSONException
     */
    private static VotingBoothConfiguration GetVotingBoothJsonConfiguration(String path) throws IOException, JSONException {
         VotingBoothConfigurationCreator creator = new VotingBoothConfigurationCreator();
         return creator.CreateConfiguration(path);
    }

    /**
     * Converts the configuration file into single binary proto file and writes it to the disc
     * @param configuration the configuration object
     */
    private static void ConvertJsonIntoBinaryFile(VotingBoothConfiguration configuration) throws IOException {
        FileOutputStream fileOutputStream = new FileOutputStream(OUTPUTNAME);
        BallotQuestionUIElementOuterClass.BallotQuestionsUIElements read_questions =
                BallotQuestionUIElementOuterClass
                        .BallotQuestionsUIElements
                        .newBuilder()
                        .addQuestions(configuration.NameSelectionByPictureQuestion)
                        .addQuestions(configuration.NameSelectionQuestion)
                        .build();
        read_questions.writeTo(fileOutputStream);
        fileOutputStream.close();
    }

    public static void main(String[] args) throws InterruptedException {
        System.out.println("args are: " + args);
        try {
            ConvertJsonIntoBinaryFile(GetVotingBoothJsonConfiguration(args[0]));
        }
        catch (Exception e) {
            System.out.println("Exception thrown: " + e);
        }
    }

}
